"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.purry = void 0;
function purry(fn, args, lazy) {
    const callArgs = Array.from(args);
    const diff = fn.length - args.length;
    if (diff === 0) {
        return fn(...callArgs);
    }
    if (diff === 1) {
        const ret = (data) => fn(data, ...callArgs);
        return lazy === undefined
            ? ret
            : Object.assign(ret, { lazy, lazyArgs: args });
    }
    throw new Error("Wrong number of arguments");
}
exports.purry = purry;
