import { purryOrderRules } from "./_purryOrderRules";
import { hasAtLeast } from "./hasAtLeast";
export function firstBy() {
    return purryOrderRules(firstByImplementation, arguments);
}
function firstByImplementation(data, compareFn) {
    if (!hasAtLeast(data, 2)) {
        return data[0];
    }
    let [currentFirst] = data;
    const [, ...rest] = data;
    for (const item of rest) {
        if (compareFn(item, currentFirst) < 0) {
            currentFirst = item;
        }
    }
    return currentFirst;
}
